## netgen 6.2.2501+dfsg1

=== CMakeLists.txt ===
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING INTERNAL)
endif(NOT CMAKE_BUILD_TYPE)

cmake_minimum_required(VERSION 3.16)
cmake_policy(VERSION 3.16)

if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.24.0")
  cmake_policy(SET CMP0135 NEW)
endif()

include (CMakeDependentOption)
option( USE_NATIVE_ARCH  "build for native cpu architecture" ON)

option( USE_GUI     "build with GUI" ON )
option( USE_PYTHON  "build with python interface" ON )
cmake_dependent_option( PREFER_SYSTEM_PYBIND11  "Use system wide PyBind11" OFF "USE_PYTHON" OFF)
option( USE_MPI     "enable mpi parallelization" OFF )
option( USE_MPI_WRAPPER "enable mpi wrapper (run-time dispatch of MPI library calls)" OFF )
option( USE_OCC     "build with OpenCascade geometry kernel interface" ON)
option( USE_STLGEOM     "build with STL geometry support" ON)
option( USE_CSG     "build with CSG kernel" ON)
option( USE_INTERFACE     "build nginterface" ON)
option( USE_GEOM2D     "build 2d geometry kernels" ON)
option( USE_JPEG    "enable snapshots using library libjpeg" OFF )
option( USE_MPEG    "enable video recording with FFmpeg, uses libavcodec" OFF )
option( USE_CGNS    "enable CGNS file read/write support" OFF )
option( USE_NUMA         "compile with NUMA-aware code")
option( INTEL_MIC        "cross compile for intel xeon phi")
option( INSTALL_PROFILES "install environment variable settings to /etc/profile.d" OFF )
option( USE_CCACHE       "use ccache")
option( USE_INTERNAL_TCL "Compile tcl files into the code and don't install them" ON)
option( ENABLE_UNIT_TESTS "Enable Catch unit tests")
option( ENABLE_CPP_CORE_GUIDELINES_CHECK "Enable cpp core guideline checks on ngcore" OFF)
option( DEBUG_LOG "Enable more debug output (may increase computation time) - only works with USE_SPDLOG=ON" OFF)
option( CHECK_RANGE "Check array range access, automatically enabled if built in debug mode" OFF)
option( BUILD_STUB_FILES "Build stub files for better autocompletion" ON)
option( BUILD_FOR_CONDA "Link python libraries only to executables" OFF)

option( USE_SUPERBUILD       "build dependencies automatically" ON)
option( TRACE_MEMORY     "Enable memory tracing" OFF)

set(NG_COMPILE_FLAGS "" CACHE STRING "Additional compile flags")

set(NGLIB_LIBRARY_TYPE SHARED CACHE STRING "nglib library type")
set(NGCORE_LIBRARY_TYPE SHARED CACHE STRING "ngcore library type")
set(NGGUI_LIBRARY_TYPE SHARED CACHE STRING "nggui library type")

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_modules")

if(APPLE)
  set(INSTALL_DIR_DEFAULT /Applications/Netgen.app)
else(APPLE)
  if(WIN32)
    set(INSTALL_DIR_DEFAULT "C:/netgen")
  else(WIN32)
    set(INSTALL_DIR_DEFAULT /opt/netgen)
  endif(WIN32)
endif(APPLE)

if(INSTALL_DIR)
  message(WARNING "INSTALL_DIR is deprecated, use CMAKE_INSTALL_PREFIX instead")
  set(INSTALL_DIR_DEFAULT ${INSTALL_DIR})
endif(INSTALL_DIR)

if(UNIX AND USE_SUPERBUILD)
  message("Checking for write permissions in install directory...")
  execute_process(COMMAND mkdir -p ${CMAKE_INSTALL_PREFIX})
  execute_process(COMMAND test -w ${CMAKE_INSTALL_PREFIX} RESULT_VARIABLE res)
  if(res)
    message(WARNING "No write access at install directory, please set correct permissions")
  endif()
endif(UNIX AND USE_SUPERBUILD)

if (USE_SUPERBUILD)
  project (SUPERBUILD)
else()
  project(Netgen)
endif()

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "${INSTALL_DIR_DEFAULT}" CACHE PATH "Install directory" FORCE)
endif()

set(NG_INSTALL_SUFFIX netgen CACHE STRING "Suffix appended to install directories (project name)")

if(USE_PYTHON)
  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.18)
      find_package(Python3 REQUIRED COMPONENTS Development.Module)
      if(NOT EMSCRIPTEN)
          find_package(Python3 COMPONENTS Interpreter Development.Embed)
      endif()
  else()
    find_package(Python3 REQUIRED COMPONENTS Interpreter Development)
  endif()

  if(NOT CMAKE_CROSSCOMPILING)
      find_package(Python3 REQUIRED COMPONENTS Interpreter)
      execute_process(COMMAND ${Python3_EXECUTABLE} -c "import os.path, sysconfig;print(os.path.relpath(sysconfig.get_path('platlib'), sysconfig.get_path('data')))" OUTPUT_VARIABLE PYTHON_PACKAGES_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
      file(TO_CMAKE_PATH ${PYTHON_PACKAGES_INSTALL_DIR} PYTHON_PACKAGES_INSTALL_DIR)
  endif(NOT CMAKE_CROSSCOMPILING)
endif(USE_PYTHON)

if(APPLE AND NOT EMSCRIPTEN)
  set(NG_INSTALL_DIR_BIN_DEFAULT Contents/MacOS)
  set(NG_INSTALL_DIR_LIB_DEFAULT Contents/MacOS)
  set(NG_INSTALL_DIR_CMAKE_DEFAULT Contents/Resources/CMake)
  set(NG_INSTALL_DIR_PYTHON_DEFAULT Contents/Resources/${PYTHON_PACKAGES_INSTALL_DIR})
  set(NG_INSTALL_DIR_RES_DEFAULT Contents/Resources/share)
  set(NG_INSTALL_DIR_INCLUDE_DEFAULT Contents/Resources/include)

  set(NG_RPATH_TOKEN "@loader_path")
else(APPLE AND NOT EMSCRIPTEN)
  set(NG_INSTALL_DIR_BIN_DEFAULT bin)
  set(NG_INSTALL_DIR_LIB_DEFAULT lib)
  if(WIN32)
    set(NG_INSTALL_DIR_CMAKE_DEFAULT cmake)
  else(WIN32)
    set(NG_INSTALL_DIR_CMAKE_DEFAULT lib/cmake/${NG_INSTALL_SUFFIX})
  endif(WIN32)
  set(NG_INSTALL_DIR_PYTHON_DEFAULT ${PYTHON_PACKAGES_INSTALL_DIR})
  set(NG_INSTALL_DIR_RES_DEFAULT share)
  set(NG_INSTALL_DIR_INCLUDE_DEFAULT include)

  set(NG_RPATH_TOKEN "\$ORIGIN")
endif(APPLE AND NOT EMSCRIPTEN)

set(NG_INSTALL_DIR_PYTHON ${NG_INSTALL_DIR_PYTHON_DEFAULT} CACHE STRING "Install directory for Python files")
set(NG_INSTALL_DIR_BIN ${NG_INSTALL_DIR_BIN_DEFAULT} CACHE STRING "Install directory for executables")
set(NG_INSTALL_DIR_LIB ${NG_INSTALL_DIR_LIB_DEFAULT} CACHE STRING "Install directory for libraries")
set(NG_INSTALL_DIR_INCLUDE ${NG_INSTALL_DIR_INCLUDE_DEFAULT} CACHE STRING "Install directory for header files")
set(NG_INSTALL_DIR_CMAKE ${NG_INSTALL_DIR_CMAKE_DEFAULT} CACHE STRING "Install directory for CMake files")
set(NG_INSTALL_DIR_RES ${NG_INSTALL_DIR_RES_DEFAULT} CACHE STRING "Install directory for resources")

get_filename_component(NETGEN_CMAKE_DIR_ABSOLUTE ${NG_INSTALL_DIR_CMAKE} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_BINARY_DIR_ABSOLUTE ${NG_INSTALL_DIR_BIN} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_LIBRARY_DIR_ABSOLUTE ${NG_INSTALL_DIR_LIB} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_INCLUDE_DIR_ABSOLUTE ${NG_INSTALL_DIR_INCLUDE} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_RESOURCE_DIR_ABSOLUTE ${NG_INSTALL_DIR_RES} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})

file(RELATIVE_PATH NETGEN_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${CMAKE_INSTALL_PREFIX})
file(RELATIVE_PATH NETGEN_BINARY_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_BINARY_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_LIBRARY_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_INCLUDE_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_INCLUDE_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_RESOURCE_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_RESOURCE_DIR_ABSOLUTE})

file(RELATIVE_PATH NETGEN_RPATH ${NETGEN_BINARY_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})

if (USE_SUPERBUILD)
  # execute the superbuild (this script will be invoked again without the
  # USE_SUPERBUILD option this time)
  include (cmake/SuperBuild.cmake)
  return()                      # stop processing this file further
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include (${CMAKE_CURRENT_LIST_DIR}/cmake/generate_version_file.cmake)
set(CPACK_PACKAGE_VERSION "${NETGEN_VERSION}")


#######################################################################
if(USE_CCACHE)
  find_program(CCACHE_FOUND NAMES ccache ccache.bat)
  if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_FOUND})
    message(STATUS "Using ccache ${CCACHE_FOUND}")
  endif(CCACHE_FOUND)
endif(USE_CCACHE)

#######################################################################
if(INTEL_MIC)
    set(MKL_ARCH "mic")
    include(cmake/mic.cmake)
else(INTEL_MIC)
    set(MKL_ARCH "intel64")
endif(INTEL_MIC)

#######################################################################
# Append install paths of software in non-standard paths (e.g. openmpi, metis, intel mkl, ...)
# cmake -DUSE_MPI=ON -DCMAKE_PREFIX_PATH="/opt/openmpi165;/opt/metis51" ../
set(ADDITIONAL_PATHS "" CACHE PATH "List of paths to additional libraries in non-standard locations, separated by ';'")
if (ADDITIONAL_PATHS)
  set(CMAKE_PREFIX_PATH ${ADDITIONAL_PATHS})
endif (ADDITIONAL_PATHS)

#######################################################################
# build options
include_directories ("${PROJECT_SOURCE_DIR}/include")
include_directories ("${PROJECT_SOURCE_DIR}/libsrc")
include_directories ("${PROJECT_SOURCE_DIR}/libsrc/include")
include_directories ("${PROJECT_BINARY_DIR}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(USE_PYTHON)
    get_filename_component(NETGEN_PYTHON_DIR_ABSOLUTE ${NG_INSTALL_DIR_PYTHON} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
    file(RELATIVE_PATH NETGEN_PYTHON_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_PYTHON_DIR_ABSOLUTE})
    file(RELATIVE_PATH NETGEN_PYTHON_RPATH_BIN ${NETGEN_PYTHON_DIR_ABSOLUTE} ${NETGEN_BINARY_DIR_ABSOLUTE})
    file(RELATIVE_PATH NETGEN_PYTHON_RPATH ${NETGEN_PYTHON_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})
    if(WIN32)
        set(NETGEN_PYTHON_RPATH ${NETGEN_PYTHON_RPATH_BIN})
    endif(WIN32)
endif(USE_PYTHON)

set(NG_INSTALL_DIR EXPORT netgen-targets RUNTIME DESTINATION ${NG_INSTALL_DIR_BIN} COMPONENT netgen LIBRARY DESTINATION ${NG_INSTALL_DIR_LIB} COMPONENT netgen_devel ARCHIVE DESTINATION ${NG_INSTALL_DIR_LIB} COMPONENT netgen_devel)
install(EXPORT netgen-targets DESTINATION ${NG_INSTALL_DIR_CMAKE} COMPONENT netgen_devel)

set(CMAKE_MACOSX_RPATH TRUE)
set(CMAKE_INSTALL_RPATH "${NG_RPATH_TOKEN};${NG_RPATH_TOKEN}/${NETGEN_RPATH}")
if(BUILD_FOR_CONDA)
    file(RELATIVE_PATH py_rpath "/bin" "/${NG_INSTALL_DIR_LIB}")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${py_rpath}")
endif(BUILD_FOR_CONDA)

include (CheckIncludeFiles)
check_include_files (dlfcn.h HAVE_DLFCN_H)
if(HAVE_DLFCN_H)
  add_definitions(-DHAVE_DLFCN_H)
endif()

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

#######################################################################
# platform specific definitions and flags
macro(get_WIN32_WINNT version)
    if (WIN32 AND CMAKE_SYSTEM_VERSION)
        if("${CMAKE_SYSTEM_VERSION}" MATCHES "^([0-9]+)\\.([0-9]+)")
            math(EXPR ver "${CMAKE_MATCH_1}*100 + ${CMAKE_MATCH_2}")
        endif()
        set(${version} "0x${ver}")
    endif()
endmacro()

macro(get_dll_from_lib dll_path lib_path)
        get_filename_component(parent_lib_path ${lib} DIRECTORY)
        get_filename_component(lib_name ${lib} name)
endmacro()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_STANDARD 17)
if(WIN32)
    set(CMAKE_MFC_FLAG 0)
endif(WIN32)
if(APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -undefined dynamic_lookup")
endif(APPLE)

#######################################################################
add_library(nglib ${NGLIB_LIBRARY_TYPE})
if(USE_GUI)
    add_library(nggui ${NGGUI_LIBRARY_TYPE})
    if(WIN32)
        set_target_properties( nggui PROPERTIES OUTPUT_NAME "libnggui")
    endif(WIN32)
endif(USE_GUI)

#######################################################################
if(NOT ZLIB_INCLUDE_DIRS)
  find_package(ZLIB REQUIRED)
endif(NOT ZLIB_INCLUDE_DIRS)
target_include_directories(nglib PRIVATE ${ZLIB_INCLUDE_DIRS})
if(USE_GUI)
    target_include_directories(nggui PRIVATE ${ZLIB_INCLUDE_DIRS})
endif(USE_GUI)

#######################################################################
if(WIN32)
    add_library(netgen_gui INTERFACE IMPORTED)
else()
    add_library(netgen_gui INTERFACE)
endif()

if (USE_GUI)
    find_package(TCL 8.5 REQUIRED)
    find_package(TclStub 8.5 REQUIRED)
    find_package(Threads REQUIRED)
    if(APPLE)

=== libsrc/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(general)
add_subdirectory(gprim)
add_subdirectory(linalg)
add_subdirectory(include)
add_subdirectory(meshing)
if(USE_OCC)
    add_subdirectory(occ)
endif(USE_OCC)
if(USE_STLGEOM)
    add_subdirectory(stlgeom)
endif(USE_STLGEOM)
if(USE_GUI)
    add_subdirectory(visualization)
endif(USE_GUI)
if(USE_INTERFACE)
    add_subdirectory(interface)
endif(USE_INTERFACE)
if(USE_CSG)
    add_subdirectory(csg)
endif(USE_CSG)
if(USE_GEOM2D)
    add_subdirectory(geom2d)
endif(USE_GEOM2D)

=== py_tutorials/CMakeLists.txt ===
install( FILES 
        shaft.geo mesh.py exportNeutral.py
        DESTINATION ${NG_INSTALL_DIR_RES}/${NG_INSTALL_SUFFIX}/py_tutorials
        COMPONENT netgen_tutorial
       )

=== rules/CMakeLists.txt ===
# this file is included from the parent directory (otherwise generated source files are not recognized properly by cmake)

# generate .cpp files containing the string of the .rls meshing rule files
if(EMSCRIPTEN)
  add_custom_command(OUTPUT makerls
    COMMAND g++ ${CMAKE_CURRENT_SOURCE_DIR}/rules/makerlsfile.cpp -o ${CMAKE_CURRENT_BINARY_DIR}/makerls
    )
  set(rules_command ${CMAKE_BINARY_DIR}/makerls)
else(EMSCRIPTEN)
  add_executable(makerls rules/makerlsfile.cpp)
  if(USE_CCACHE)
    set_target_properties(makerls PROPERTIES RULE_LAUNCH_COMPILE "")
  endif(USE_CCACHE)
  set(rules_command makerls)
endif()

set(rules
    hexrules
    prismrules2
    pyramidrules
    pyramidrules2
    quadrules
    tetrules
    triarules
)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/rules/)

foreach(rule ${rules})
    list(APPEND rules_sources ${CMAKE_CURRENT_BINARY_DIR}/rules/rule_${rule}.cpp)
    set(rule_file ${CMAKE_CURRENT_SOURCE_DIR}/rules/${rule}.rls)
    set(rule_cpp ${CMAKE_CURRENT_BINARY_DIR}/rules/rule_${rule}.cpp)

    add_custom_command(OUTPUT ${rule_cpp}
      COMMAND ${rules_command} ${rule_file} ${rule_cpp} ${rule}
      DEPENDS makerls ${rule_file}
    )
endforeach()

target_sources(nglib PRIVATE ${rules_sources})

=== tests/CMakeLists.txt ===
add_subdirectory(catch)
add_subdirectory(pytest)

# this code goes here, because tests is the last add_subdirectory (otherwise it gets executed too early)
if(APPLE AND BUILD_FOR_CONDA)
    install(CODE "execute_process(COMMAND sh -c \"codesign --force -s - netgen/*.so netgen/*.dylib pyngcore/*.so\" WORKING_DIRECTORY ${CMAKE_INSTALL_PREFIX})")
endif(APPLE AND BUILD_FOR_CONDA)

=== libsrc/meshing/CMakeLists.txt ===
target_sources(nglib PRIVATE
        adfront2.cpp adfront3.cpp bisect.cpp boundarylayer.cpp 
        clusters.cpp curvedelems.cpp delaunay.cpp delaunay2d.cpp	    
        geomsearch.cpp global.cpp hprefinement.cpp improve2.cpp		    
        improve2gen.cpp improve3.cpp localh.cpp meshclass.cpp		    
        meshfunc.cpp meshfunc2d.cpp meshing2.cpp meshing3.cpp		    
        meshtool.cpp meshtype.cpp msghandler.cpp netrule2.cpp		    
        netrule3.cpp parser2.cpp parser3.cpp refine.cpp		    
        ruler2.cpp ruler3.cpp secondorder.cpp smoothing2.5.cpp		    
        smoothing2.cpp smoothing3.cpp specials.cpp
        topology.cpp validate.cpp bcfunctions.cpp   
        parallelmesh.cpp  paralleltop.cpp  basegeom.cpp
        python_mesh.cpp surfacegeom.cpp
        debugging.cpp fieldlines.cpp visual_interface.cpp
        boundarylayer2d.cpp boundarylayer_interpolate.cpp
)

target_link_libraries( nglib PRIVATE $<BUILD_INTERFACE:netgen_metis> $<BUILD_INTERFACE:netgen_python> )

install(FILES
  adfront2.hpp adfront3.hpp basegeom.hpp bcfunctions.hpp bisect.hpp
  boundarylayer.hpp classifyhpel.hpp clusters.hpp curvedelems.hpp
  findip2.hpp findip.hpp geomsearch.hpp global.hpp hpref_hex.hpp
  hprefinement.hpp hpref_prism.hpp hpref_pyramid.hpp hpref_quad.hpp
  hpref_segm.hpp hpref_tet.hpp hpref_trig.hpp improve2.hpp improve3.hpp
  localh.hpp meshclass.hpp meshfunc.hpp meshing2.hpp meshing3.hpp
  meshing.hpp meshtool.hpp meshtype.hpp msghandler.hpp paralleltop.hpp
  ruler2.hpp ruler3.hpp specials.hpp topology.hpp validate.hpp
  python_mesh.hpp surfacegeom.hpp delaunay2d.hpp
  fieldlines.hpp soldata.hpp visual_interface.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/meshing COMPONENT netgen_devel
)

=== libsrc/visualization/CMakeLists.txt ===
target_sources(nggui PRIVATE
    importsolution.cpp
    meshdoc.cpp
    mvdraw.cpp
    vsfieldlines.cpp
    vsmesh.cpp
    vssolution.cpp
    visualpkg.cpp
)
target_link_libraries( nggui PUBLIC "$<BUILD_INTERFACE:netgen_python>" ${OPENGL_LIBRARIES} nglib)

install(FILES
  meshdoc.hpp mvdraw.hpp visual_api.hpp
  vispar.hpp visual.hpp vssolution.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/visualization COMPONENT netgen_devel
)

=== debian/changelog ===
netgen (6.2.2501+dfsg1-12) unstable; urgency=medium

  * Team upload.
  * apply armel test skips to debian/tests (netgen-test-python)

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Apr 2025 15:40:49 +0200

netgen (6.2.2501+dfsg1-11) unstable; urgency=medium

  * Team upload.
  * armel: skip test_BBNDsave
    Now it passes, now it fails. This is madness.

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 22:20:09 +0200

netgen (6.2.2501+dfsg1-10) unstable; urgency=medium

  * Team upload.
  * There are too many pytest segfaults on armel.
    Skip all test_geoFiles

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 18:31:12 +0200

netgen (6.2.2501+dfsg1-9) unstable; urgency=medium

  * Team upload.
  * armel: skip test_geoFiles[boundarycondition

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 15:51:37 +0200

netgen (6.2.2501+dfsg1-8) unstable; urgency=medium

  * Team upload.
  * armel: skip test_2_polyhedra and all slow tests
    (internal skips are causing segfaults)

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 12:18:24 +0200

netgen (6.2.2501+dfsg1-7) unstable; urgency=medium

  * Team upload.
  * armel: skip all tests that need ngsolve.  importorskip in-test
    is triggering segfaults on armel

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 00:47:30 +0200

netgen (6.2.2501+dfsg1-6) unstable; urgency=medium

  * Team upload.
  * armel: skip test_wrong_orientation

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Apr 2025 19:03:46 +0200

netgen (6.2.2501+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * armel: skip test_geoFiles[sphereincube

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Apr 2025 09:45:45 +0200

netgen (6.2.2501+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * armel: skip test_geoFiles[cubeandspheres build tests
  * sparc64: skip all occ tests

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Apr 2025 18:38:53 +0200

netgen (6.2.2501+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * skip failing tests
    - armel: test_boundarylayer2
    - powerpc: actually skip test_geoFiles[sphereincube.geo-mp161-4]
    - sparc64: skip all test_occ (is it a numpy linalg issue?)

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Apr 2025 10:42:40 +0200

netgen (6.2.2501+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * skip failing tests on less common architectures
    - armel: test_mesh_elements_numpy_array_access
    - powerpc: test_geoFiles[sphereincube.geo-mp161-4]
    - sparc64: test_rect_with_two_holes
  * debian/copyright: update FSF address used in LGPL

 -- Drew Parsons <dparsons@debian.org>  Sun, 06 Apr 2025 20:08:13 +0200

netgen (6.2.2501+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * reduce debian patch size_t_int32.patch: upstream has added some
    int size checks in table.hpp
  * mark libnglib-dev Multi-Arch: same
  * debian/control: set Homepage: https://github.com/NGSolve/netgen
    to avoid confusion with ngsolve. Also Source in debian/copyright.
  * drop redundant ng/Togl-1.7 exclusions from debian/copyright
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Apr 2025 11:49:01 +0200

=== debian/control ===
Source: netgen
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kurt Kremitzki <kkremitzki@debian.org>
Section: math
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), catch2,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               libtool,
               tcl-dev,
               tk-dev,
               tix-dev,
               docbook-to-man,
               libxmu-dev,
               libglu1-mesa-dev,
               libmetis-dev,
               libocct-data-exchange-dev (>=7.8.1+dfsg1),
               libocct-foundation-dev (>=7.8.1+dfsg1),
               libocct-modeling-algorithms-dev (>=7.8.1+dfsg1),
               libocct-visualization-dev (>=7.8.1+dfsg1),
               libocct-ocaf-dev (>=7.8.1+dfsg1),
               libtbb-dev,
               mpi-default-dev,
               libtogl-dev,
               libavformat-dev,
               libswscale-dev,
               libjpeg-dev,
               libbz2-dev,
               pybind11-dev,
               python3-dev,
               python3-dbg,
               python3-mpi4py,
               python3-numpy,
               python3-pytest,
               python3-tk
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/netgen
Vcs-Git: https://salsa.debian.org/science-team/netgen.git
Homepage: https://github.com/NGSolve/netgen

Package: netgen
Architecture: any
Depends: libnglib-6.2t64 (= ${binary:Version}),
         mpi-default-bin [!mips !mipsel !ppc64el],
         tix,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: netgen-doc
Description: Automatic 3d tetrahedral mesh generator
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format.  NETGEN contains modules
 for mesh optimization and hierarchical mesh refinement.

Package: netgen-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: netgen
Description: Automatic 3d tetrahedral mesh generator documentation
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format.  NETGEN contains modules
 for mesh optimization and hierarchical mesh refinement.
 .
 This package contains the user manual (in PDF format) and example
 files.

Package: libnglib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnglib-6.2t64 (= ${binary:Version}),
         pybind11-dev,
         ${misc:Depends}
Recommends: netgen, python3-netgen
Conflicts: netgen-headers (<< 6.2.2305~)
Breaks: libnglib-6.2.1804
Replaces: libnglib-6.2.1804
Description: Automatic 3d tetrahedral mesh generator development files
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains the static libraries and header files.

Package: libnglib-6.2t64
Provides: ${t64:Provides}
Replaces: libnglib-6.2
Breaks: libnglib-6.2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic 3d tetrahedral mesh generator shared library
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains the shared libraries.

Package: netgen-headers
Architecture: any
Section: libdevel
Depends: libnglib-dev (= ${binary:Version}),
         ${misc:Depends}
Description: Automatic 3d tetrahedral mesh generator internal headers
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains internal headers.

Package: python3-netgen
Architecture: any
Section: python
Depends: libnglib-6.2t64 (= ${binary:Version}),
         python3-tk,
         ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: ${python3:Provides}
Description: Automatic 3d tetrahedral mesh generator Python 3 bindings
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains Python 3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

include /usr/share/dpkg/architecture.mk

DEB_VERSION := $(shell dpkg-parsechangelog -S Version)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/[\.\+]dfsg.*$$//' )

# upstream script generate_version_file.cmake uses leading v
# use with tweak version 0 to trigger a short upstream version
NETGEN_VERSION = v$(DEB_STRIPPED_UPSTREAM_VERSION)-0

PY3DEF := $(shell py3versions -dv | sed "s/\.//")

%:
	dh $@ --with=python3 --buildsystem=cmake

export MACHINE=LINUX

extra_flags += \
	-DNETGEN_VERSION_GIT=$(NETGEN_VERSION) \
	-DNG_INSTALL_DIR_INCLUDE:PATH=include/netgen \
	-DPREFER_SYSTEM_PYBIND11=ON \
	-DBUILD_STUB_FILES=OFF \
	-DUSE_OCC:BOOL=ON \
	-DUSE_JPEG:BOOL=ON \
	-DUSE_MPEG:BOOL=ON \
	-DUSE_SUPERBUILD:BOOL=OFF \
	-DUSE_NATIVE_ARCH:BOOL=OFF \
	-DUSE_MPI:BOOL=ON \
	-DUSE_MPI4PY:BOOL=ON \
	-DENABLE_UNIT_TESTS=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_RPATH=ON

execute_after_dh_clean:
	rm -rf tests/pytest/__pycache__ tests/pytest/.pytest_cache tests/pytest/*vol.gz

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	sed -i s/DEB_HOST_MULTIARCH/${DEB_HOST_MULTIARCH}/ debian/netgen.desktop

ifneq ($(DEB_HOST_ARCH),amd64)
# this subset of demo tests (test_tutorials.py::test_geoFiles)
# only passes on amd64
    SKIP_TEST_LIST += boxcyl.geo-mp11-5 \
	cylsphere.geo-mp58-4 cylsphere.geo-mp61-1 cylsphere.geo-mp64-4 \
	hinge.stl-mp93-5 hinge.stl-mp99-5 part1.stl-mp129-1 \
	part1.stl-mp123-1 part1.stl-mp126-4 part1.stl-mp132-4 \
	sculpture.geo-mp143-4 sculpture.geo-mp149-4 \
	sphereincube.geo-mp162-5 sphereincube.geo-mp168-5 \
	twobricks.geo-mp195-2 twobricks.geo-mp199-0 twobricks.geo-mp201-2 twobricks.geo-mp202-3 \
	twocubes.geo-mp201-2 twocubes.geo-mp205-0 twocubes.geo-mp207-2 twocubes.geo-mp208-3
endif

ifeq ($(DEB_HOST_ARCH),armel)
    # ngsolve import-or-skip triggers segfaults on armel
    SKIP_TEST_LIST += test_mesh_elements_numpy_array_access \
	test_boundarylayer2 test_wrong_orientation test_splitted_surface test_pyramids \
	test_csg2d test_rect_with_two_holes test_unit_square test_box_and_cyl \
	test_2_polyhedra test_BBNDsave

    # too many pytest segfaults on armel. Skip all test_geoFiles
    SKIP_TEST_LIST += test_geoFiles
endif

ifeq ($(DEB_HOST_ARCH),i386)
    CXXFLAGS += -ffloat-store
endif

ifeq ($(DEB_HOST_ARCH),powerpc)
    SKIP_TEST_LIST += test_geoFiles[sphereincube.geo-mp161-4]
endif

ifeq ($(DEB_HOST_ARCH),sparc64)
    SKIP_TEST_LIST += occ
endif

override_dh_auto_test:
	dh_auto_install
	list_initialised=0; \
        for t in $(SKIP_TEST_LIST); do \
            if [ $${list_initialised} = 0 ]; then \
                SKIP_TESTS=$$t; \
                list_initialised=1; \
            else \
                SKIP_TESTS="$${SKIP_TESTS} or $$t"; \
            fi; \
        done; \
        if [ "x$${SKIP_TESTS}" != "x" ]; then \
            SKIP_TESTS="not ( $${SKIP_TESTS} )"; \
        fi; \
        echo "skipping tests: $${SKIP_TESTS}"; \
	cd tests/pytest && \
          PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
          LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
          python3 -m pytest -v -k "$${SKIP_TESTS}"

execute_after_dh_python3-arch:
	for pylib in libngpy libngguipy; do \
	  pylib_dh=`basename debian/python3-netgen/usr/lib/python3/dist-packages/netgen/$${pylib}*$(PY3DEF)*.so`; \
	  sed "s|netgen/$${pylib}.so|netgen/$${pylib_dh}|" -i debian/libnglib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/netgen/netgen-targets-relwithdebinfo.cmake; \
	done

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/${DEB_HOST_MULTIARCH}/netgen

=== debian/tests/control ===
Tests: netgen-test-cpp
Depends: libnglib-dev,
 netgen, python3-netgen,
 gcc, g++, cmake, catch2,
 mpi-default-dev
Restrictions: allow-stderr

Tests: netgen-test-python
Depends: python3-netgen,
 gcc, python3-numpy,
 python3-pytest, python3-pytest-mpi,
 mpi-default-bin, python3-mpi4py

## netgen 6.2.2601%2Bdfsg1

=== debian/changelog ===
netgen (6.2.2601+dfsg1-3ubuntu1) resolute; urgency=medium

  * Also skip test_geoFiles on amd64v3 (LP: #2137482)

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 22 Feb 2026 12:31:46 +0000

netgen (6.2.2601+dfsg1-3) unstable; urgency=medium

  * Pass -flax-vector-conversions to CXXFLAGS on arm64 also in
    debian/tests/netgen-test-cpp
  * Drop redundant Priority field from d/control

 -- Francesco Ballarin <ballarin@debian.org>  Sun, 22 Feb 2026 06:40:09 +0000

netgen (6.2.2601+dfsg1-2) unstable; urgency=medium

  * Add -flax-vector-conversions to CXXFLAGS on arm64 to avoid build failures
    due to conversion errors. An issue is already open upstream at
    https://github.com/NGSolve/netgen/issues/226

 -- Francesco Ballarin <ballarin@debian.org>  Fri, 20 Feb 2026 12:18:42 +0000

netgen (6.2.2601+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Add Francesco Ballarin to uploaders.
  * Standards-Version: 4.7.3 (routine-update)
  * Update watch file format version to 5.
  * Add dversionmangle for repack versioning in debian/watch.
  * Reorder Files paragraphs in debian/copyright by directory depth.
  * Set upstream metadata fields: Bug-Database, Repository.
  * debputy lint --auto-fix (routine-update)
  * Apply multi-arch hint:
    - netgen-headers: Add Multi-Arch: same.
  * Add debian/clean (from Alexandre Detiste)
  * Add debian/salsa-ci.yml (from Alexandre Detiste)
  * Use dh-sequence-python3 (from Alexandre Detiste)
  * Drop "Rules-Requires-Root: no", as it is the default now (from Alexandre
    Detiste)
  * Refresh patches
  * Add link-libjpeg-netgen-exec.patch to force netgen executable to link
    libjpeg.
  * Fix lintian warning old-fsf-address-in-copyright-file.

 -- Francesco Ballarin <ballarin@debian.org>  Fri, 20 Feb 2026 10:18:29 +0000
